<%

	strReferenceNumber = Request.Form("strReferenceNumber")
	strCashierNumber = Request.Form("strCashierNumber")
	strTransactionAmount = Request.Form("strTransactionAmount")
	strSalesTaxAmount = Request.Form("strSalesTaxAmount")
	strAccountNumber = Request.Form("strAccountNumber")
	strExpirationMonth = Request.Form("strExpirationMonth")
	strExpirationYear = Request.Form("strExpirationYear")
	strBillingName = Request.Form("strBillingName")
	strBillingAddress = Request.Form("strBillingAddress")
	strBillingCity = Request.Form("strBillingCity")
	strBillingState = Request.Form("strBillingState")
	strBillingPostalCode = Request.Form("strBillingPostalCode")
	strBillingPhone = Request.Form("strBillingPhone")
	strBillingEmail = Request.Form("strBillingEmail")


const TEST_MODE = true 
const VIEW_XML_REQUEST = false
const VIEW_XML_RESPONSE = false
dim strXmlRequest

Quote = String(1,34) 
If (TEST_MODE) Then
   strDLLUrl   = "https://testefsnet.concordebiz.com/EFSnet.dll" 

'==========================================
   strStoreID  = "Your Test Store ID"
   strStoreKey = "Your Test Store Key"

'==========================================
  
Else ' Live Mode
   strDLLUrl = "https://efsnet.concordebiz.com/EFSnet.dll"   
   strStoreID  = "Issued Live Account StoreID Goes Here"
   strStoreKey = "Issued Live Account StoreKey Goes Here"
End If   

'---------------------------------------------------------------------------
' For simplicity in this sample, we'll only populate variables for a 
' SystemCheck.  For other methods, required fields such as 
' "strTransactionAmount" would need to be populated before creating the 
' XML Request Message.  Notice how easy it is to use ANY EFSnet method 
' by changing just one variable.  
'---------------------------------------------------------------------------
' Populate Transaction Request Variables
strApplicationID = "myApp"

strMethodName = "Authorize" 
Select Case strMethodName
   ' Build a properly formatted EFSnet XML Request Message 
   Case "SysCheck"  LoadXmlRequest("EFSnet:SystemCheck")  
   Case "Authorize" LoadXmlRequest("EFSnet:CreditCardAuthorize")
   Case "Settle"    LoadXmlRequest("EFSnet:CreditCardSettle")  
   Case "Charge"    LoadXmlRequest("EFSnet:CreditCardCharge") 'Auth/Settle
   Case "Refund"    LoadXmlRequest("EFSnet:CreditCardRefund")  
End Select

'---------------------------------------------------------------------------
' This allows us to view the Request Message in a IE5+ Browser.
' Note that you may need to open a new browser session to get the XML
' to display properly.
'---------------------------------------------------------------------------
If VIEW_XML_REQUEST Then
   ' Debugging: View XML Request
   Response.ContentType = "text/xml"
   Response.Write strXmlRequest
   Response.end
End If  

ProcessXMLRequest()   'Send EFSNet Request Message, Parse Response

' Business logic to handle transaction response would go here....
' END OF MAIN CODE


'---------------------------------------------------------------------------
' HELPER FUNCTIONS
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
' Instead of passing a huge list of parameters to this SubRoutine, we opt
' to use global variables that hold information required for a transaction.
' The power of XML is that elements that are not needed by the EFSnet Method
' being called will simply be ignored.  This allows us to use this 
' simple LoadXmlRequest method for ALL potential calls to EFSnet.
'---------------------------------------------------------------------------
Sub LoadXmlRequest(strRequestType)
   strXmlRequest = "<EFSnet:Request xmlns:EFSnet=" & Quote & strDLLUrl & _
		   Quote & " StoreID=" & Quote & strStoreID & Quote & _
		   " StoreKey=" & Quote & strStoreKey & Quote & _
		   " ApplicationID=" & Quote & strApplicationID & Quote & ">"
   AddString "<" & strRequestType & ">"
   AddElement "ReferenceNumber"   , strReferenceNumber   
   AddElement "CashierNumber"     , strCashierNumber     
   AddElement "TransactionAmount" , strTransactionAmount 
   AddElement "SalesTaxAmount"    , strSalesTaxAmount    
   AddElement "Currency"          , strCurrency          
   AddString ""
	 AddElement "AccountNumber"     , strAccountNumber     
	 AddElement "ExpirationMonth"   , strExpirationMonth   
	 AddElement "ExpirationYear"    , strExpirationYear    
	 AddElement "CardVerificationValue", strCardVerificationValue
	 AddElement "Track1", strTrack1
	 AddElement "Track2", strTrack2
	 AddElement "TerminalID", strTerminalID
   AddString ""                               
   AddString ""
	 AddElement "BillingName"       , strBillingName       
	 AddElement "BillingAddress"    , strBillingAddress    
	 AddElement "BillingCity"       , strBillingCity       
	 AddElement "BillingState"      , strBillingState      
	 AddElement "BillingPostalCode" , strBillingPostalCode 
	 AddElement "BillingCountry"    , strBillingCountry    
	 AddElement "BillingPhone"      , strBillingPhone      
	 AddElement "BillingEmail"      , strBillingEmail      
   AddString ""
   AddString ""
	 AddElement "ShippingName"      , strShippingName      
	 AddElement "ShippingAddress"   , strShippingAddress   
	 AddElement "ShippingCity"      , strShippingCity      
	 AddElement "ShippingState"     , strShippingState     
	 AddElement "ShippingPostalCode", strShippingPostalCode
	 AddElement "ShippingCountry"   , strShippingCountry   
	 AddElement "ShippingPhone"     , strShippingPhone     
	 AddElement "ShippingEmail"     , strShippingEmail     
   AddString ""
   AddElement "ClientIPAddress", strClientIPAddress   
   AddString "</" & strRequestType & ">"
   AddString "</EFSnet:Request>"
End Sub

'---------------------------------------------------------------------------
Sub AddString (str)
   strXmlRequest = strXmlRequest & str
End Sub

'---------------------------------------------------------------------------
Sub AddElement (strFieldName, strFieldValue)
   strXmlRequest = strXmlRequest & "<" & strFieldName & ">" & _
   strFieldValue & "</" & strFieldName & ">"
End Sub
   
'---------------------------------------------------------------------------
Sub ProcessXMLRequest()             
   Dim objXMLdoc, objHttp, objRoot

   Set objXMLdoc = Server.CreateObject("MSXML2.DOMDocument")
   objXMLdoc.async = False
   objXMLdoc.setProperty "ServerHTTPRequest", true
   objXMLdoc.loadXML strXmlRequest
   Set objHttp = Server.CreateObject("Msxml2.ServerXMLHTTP")
   objHttp.Open "POST", strDLLUrl, False
   objHttp.send objXMLdoc

   ' Load the xml response back into our Dom object for parsing
   objXMLdoc.loadXML objHttp.responseXML.Xml
	
   If VIEW_XML_RESPONSE Then
      ' Debugging: View XML Response
      Response.ContentType = "text/xml"
      Response.Write objHttp.responseXML.Xml
      Response.end
   End If  
   
   ' Parse the xml result into class member vars
   objXMLdoc.setProperty "SelectionNamespaces", _
			 "xmlns:EFSnet='http://efsnet.concordebiz.com'"
   Set objRoot = objXMLdoc.selectSingleNode( _
		 "EFSnet:Reply/EFSnet:TransactionReply") 
   intResponseCode        = CInt(ExtractNodeItem (objRoot, "ResponseCode"))
   strResultCode          = ExtractNodeItem (objRoot, "ResultCode")
   strResultMessage       = ExtractNodeItem (objRoot, "ResultMessage")
   strTransactionID       = ExtractNodeItem (objRoot, "TransactionID")
   strAVSResponseCode     = ExtractNodeItem (objRoot, "AVSResponseCode")
   strCVVResponseCode     = ExtractNodeItem (objRoot, "CVVResponseCode")
   strApprovalNumber      = ExtractNodeItem (objRoot, "ApprovalNumber")
   strAuthorizationNumber = ExtractNodeItem (objRoot, "AuthorizationNumber")
   strTransactionDate     = ExtractNodeItem (objRoot, "TransactionDate")
   strTransactionTime     = ExtractNodeItem (objRoot, "TransactionTime")

   If ResponseCode <> 0 Then
      Response.Write "Oops - We Failed <BR>"
   Else
      Response.Write "Success! <BR>"
   End If   
   Response.Write "ResponseCode = " & intResponseCode & "<BR>"
   Response.Write "ResultMessage = " & strResultMessage & "<BR>"
   Response.Write "ResultMessage = " & strAuthorizationNumber  & "<BR>"
   Response.Write "ResultMessage = " & strTransactionDate     
   
   set objRoot   = Nothing
   Set objXMLdoc = Nothing
   Set objHttp   = Nothing
End Sub


'---------------------------------------------------------------------------
Function ExtractNodeItem(objRoot, strNodeName)
   Dim objNode
   set objNode = objRoot.selectSingleNode(strNodeName) 
   if objNode is Nothing then 
       ExtractNodeItem = ""
   else 
       ExtractNodeItem = objNode.text
   end if                 
   set objNode = Nothing
End Function
%>

